DROP TABLE RECHERCHE.PROGRAMMES;

CREATE TABLE RECHERCHE.PROGRAMMES
(
ID NUMBER NOT NULL,
CODE VARCHAR2(25) NOT NULL,
C_STRUCTURE VARCHAR2(10) NOT NULL,
LL_PROGRAMME VARCHAR2(100) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER NOT NULL,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE NOT NULL,
MODIFIABLE NUMBER(1) NOT NULL
);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (
	CONSTRAINT FK_PROG_REF_STRUCT 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);


CREATE SEQUENCE RECHERCHE.PROGRAMMES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;


CREATE TABLE RECHERCHE.PROGRAMME_ANNEES
(
	ID NUMBER NOT NULL,
	ANNEE NUMBER NOT NULL,
	PROGRAMME_ID NUMBER NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL, 
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL, 
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.PROGRAMME_ANNEES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.PROGRAMME_ANNEES ADD (
	CONSTRAINT FK_PA_REF_PROGRAMME 
	FOREIGN KEY (PROGRAMME_ID) 
	REFERENCES RECHERCHE.PROGRAMMES (ID) DEFERRABLE INITIALLY DEFERRED
);

CREATE SEQUENCE RECHERCHE.PROGRAMME_ANNEES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;


CREATE OR REPLACE PROCEDURE RECHERCHE.INSERT_OR_UPDATE_PROGRAMME (
    CODE_PROGRAMME RECHERCHE.PROGRAMMES.CODE%TYPE,
    LL_PROGRAMME RECHERCHE.PROGRAMMES.LL_PROGRAMME%TYPE,
    C_STRUCTURE RECHERCHE.PROGRAMMES.C_STRUCTURE%TYPE,
    MODIFIABLE RECHERCHE.PROGRAMMES.MODIFIABLE%TYPE,
    UTL_PERS_ID RECHERCHE.PROGRAMMES.PERS_ID_CREATION%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------
persid INTEGER;
count_existant INTEGER;
modifiable_existant NUMBER(1);
-- ---------
-- PRINCIPAL
-- ---------
BEGIN


  if UTL_PERS_ID IS NULL then  
    select pers_id  into persid from grhum.grhum_parametres gp inner join grhum.compte c on gp.param_value = c.cpt_login where param_key = 'GRHUM_CREATEUR' and rownum = 1;
  else 
    persid := UTL_PERS_ID; 
  end if;

  select count(*) into count_existant from recherche.programmes where code = CODE_PROGRAMME;
  
  if count_existant = 1 then
      select modifiable into modifiable_existant from recherche.programmes where code = CODE_PROGRAMME;
      if modifiable_existant = 1 then
        update recherche.programmes set c_structure = C_STRUCTURE, ll_programme = LL_PROGRAMME, pers_id_modification = persid, d_modification = sysdate where code = CODE_PROGRAMME;
      end if;
  else
    insert into recherche.programmes (id, code, c_structure, ll_programme, pers_id_creation, pers_id_modification, d_creation, d_modification, modifiable) values (recherche.programmes_seq.nextval, CODE_PROGRAMME, C_STRUCTURE, LL_PROGRAMME, persid, persid, sysdate, sysdate, MODIFIABLE);
  end if;
  



END;
/


  
-- la date de depot peut etre nulle
ALTER TABLE RECHERCHE.AAP  
MODIFY (DATE_DEPOT_DOSSIER NULL);





